package response

import (
	"github.com/iotaledger/goshimmer/plugins/autopeering/protocol/constants"
	"github.com/iotaledger/goshimmer/plugins/autopeering/types/peer"
)

const (
	TYPE_REJECT = Type(0)
	TYPE_ACCEPT = Type(1)

	MARSHALED_PEERS_AMOUNT   = constants.NEIGHBOR_COUNT + constants.NEIGHBOR_COUNT*constants.NEIGHBOR_COUNT
	MARHSALLED_PACKET_HEADER = 0xBC

	MARSHALED_PACKET_HEADER_START = 0
	MARSHALED_TYPE_START          = MARSHALED_PACKET_HEADER_END
	MARSHALED_ISSUER_START        = MARSHALED_TYPE_END
	MARSHALED_PEERS_START         = MARSHALED_ISSUER_END
	MARSHALED_SIGNATURE_START     = MARSHALED_PEERS_END

	MARSHALED_PACKET_HEADER_END = MARSHALED_PACKET_HEADER_START + MARSHALED_PACKET_HEADER_SIZE
	MARSHALED_TYPE_END          = MARSHALED_TYPE_START + MARSHALED_TYPE_SIZE
	MARSHALED_PEERS_END         = MARSHALED_PEERS_START + MARSHALED_PEERS_SIZE
	MARSHALED_ISSUER_END        = MARSHALED_ISSUER_START + MARSHALED_ISSUER_SIZE
	MARSHALED_SIGNATURE_END     = MARSHALED_SIGNATURE_START + MARSHALED_SIGNATURE_SIZE

	MARSHALED_PACKET_HEADER_SIZE = 1
	MARSHALED_TYPE_SIZE          = 1
	MARSHALED_ISSUER_SIZE        = peer.MARSHALED_TOTAL_SIZE
	MARSHALED_PEER_FLAG_SIZE     = 1
	MARSHALED_PEER_SIZE          = MARSHALED_PEER_FLAG_SIZE + peer.MARSHALED_TOTAL_SIZE
	MARSHALED_PEERS_SIZE         = MARSHALED_PEERS_AMOUNT * MARSHALED_PEER_SIZE
	MARSHALED_SIGNATURE_SIZE     = 65
	MARSHALED_TOTAL_SIZE         = MARSHALED_SIGNATURE_END
)
